package de.mrbesen.telegram.event.events;

import org.json.JSONObject;

import de.mrbesen.telegram.event.Event;
import de.mrbesen.telegram.objects.TMessage;
import de.mrbesen.telegram.objects.TUser;

public class UserCallbackEvent extends Event {

	private final String data;
	private final TMessage msg;
	
	public UserCallbackEvent(TUser u, String data, TMessage msg) {
		super(u);
		this.data = data;
		this.msg = msg;
	}

	public TMessage getMsg() {
		return msg;
	}

	public String getData() {
		return data;
	}

	public JSONObject asJSON() {
		return new JSONObject(data);
	}

}
